'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.genClass = genClass;
exports.addMethod = addMethod;
exports.addMethods = addMethods;
exports.addProperty = addProperty;

var _esquery = require('esquery');

var _esquery2 = _interopRequireDefault(_esquery);

var _estemplate = require('estemplate');

var _estemplate2 = _interopRequireDefault(_estemplate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function genClass(name, base) {
    // 利用estemplate生成class模板
    let template = '';
    if (base) {
        template = 'class <%= name %> extends <%= base %> {}';
    } else {
        template = 'class <%= name %> {}';
    }
    return (0, _estemplate2.default)(template, {
        name: {
            type: 'Identifier',
            name: name
        },
        base: {
            type: 'Identifier',
            name: base
        }
    });
}

function addMethod(classAst, methodAst) {
    if (!methodAst) {
        return;
    }
    // 找到classbody部分
    let classBody = (0, _esquery2.default)(classAst, 'ClassBody')[0];
    // 把computed放到body里
    classBody.body = [...classBody.body, methodAst];

    return classAst;
}

function addMethods(classAst, methodAstArr) {
    // 找到classbody部分
    let classBody = (0, _esquery2.default)(classAst, 'ClassBody')[0];
    // 把computed放到body里
    classBody.body = [...classBody.body, ...methodAstArr];

    return classAst;
}

function addProperty(classAst, property) {
    if (!property) {
        return;
    }
    // 找到classbody部分
    let classBody = (0, _esquery2.default)(classAst, 'ClassBody')[0];
    // 把computed放到body里
    classBody.body.unshift(property);
}