'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.parse = parse;
exports.replace = replace;

var _espree = require('espree');

var _espree2 = _interopRequireDefault(_espree);

var _estraverse = require('estraverse');

var _estraverse2 = _interopRequireDefault(_estraverse);

var _parseOptions = require('./parseOptions');

var _parseOptions2 = _interopRequireDefault(_parseOptions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function parse(code, options) {

    options = Object.assign({}, _parseOptions2.default, options);

    return _espree2.default.parse(code, options);
}

function replace(ast, originalAst, newAst) {
    _estraverse2.default.replace(ast, {
        enter: function (node) {
            if (node === originalAst) {
                this.break();
                return newAst;
            }
        }
    });
    return ast;
}