'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.webpackConfigPath = exports.packagePath = exports.outputPath = exports.defaultExportName = exports.baseDir = exports.customConfig = undefined;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let runPath = process.cwd();

let customConfig = {};

let rcPath = _path2.default.resolve(runPath, '.vpsrc');

if (_fs2.default.existsSync(rcPath)) {
    exports.customConfig = customConfig = JSON.parse(_fs2.default.readFileSync(rcPath));
}

exports.customConfig = customConfig;

// short name

let cc = customConfig;

const baseDir = exports.baseDir = cc.baseDir ? _path2.default.resolve(runPath, cc.baseDir) : _path2.default.resolve(runPath);

// export const baseClassPath = cc.baseClassPath || path.resolve('./base/vue');

const defaultExportName = exports.defaultExportName = cc.defaultExportName || 'defaultexport';

if (defaultExportName === 'default') {
    throw '"default" is a key word in php, please DON\'T use "default" as default export name.';
}

const outputPath = exports.outputPath = cc.outputPath ? _path2.default.resolve(runPath, cc.outputPath) : _path2.default.resolve(runPath, './output');

const packagePath = exports.packagePath = cc.packagePath ? _path2.default.resolve(runPath, cc.packagePath) : _path2.default.resolve(runPath, './node_modules/vue-php-packages');

const webpackConfigPath = exports.webpackConfigPath = cc.webpackConfigPath ? _path2.default.resolve(runPath, cc.webpackConfigPath) : _path2.default.resolve(runPath, './webpack.config.js');